# ../addons/eventscripts/superdice/superdice.py
##########################
#~~~~~~~Super~Dice~~~~~~~#
#~~~~~~~~~By~MiB~~~~~~~~~#
##########################
import es,random,cmdlib,popuplib,gamethread
import psyco
psyco.full()

roundend = 0
blocks = {}
players = {}
variables = ["superdice_rollchance","superdice_shout","superdice_healthmod","superdice_superhealthmod","superdice_cursemod","superdice_tmp","superdice_tmp1","superdice_tmp2","superdice_timemod","superdice_lustmod"]
subscripts = ["superdiceblocks"]
maindir = "addons/eventscripts/superdice"
configdir = "cfg/eventscripts/superdice"
events = "%s/superdice.res"%maindir
config = "../%s/superdice.cfg"%configdir

def load():
	for script in subscripts: es.load("superdice/%s"%script)
	for var in variables: es.ServerVar(var).set(0)
	cmdlib.registerServerCommand("superdice_addblock",AddBlock,"Adds a block to Super Dice's blocks list. | superdice_addblock <blockname> <rollname> <rolldesc>")
	cmdlib.registerServerCommand("superdice_removeblock",RemoveBlock,"Removes a block from Super Dice's blocks list. | superdice_removeblock <block name>")
	cmdlib.registerServerCommand("superdice_clearblocks",ClearBlocks,"Clears the blocks from Super Dice's blocks list. | superdice_clearblocks")
	cmdlib.registerServerCommand("superdice_reloadblocks",ReloadBlocks,"Reloads Super Dice's superdiceblocks script. | superdice_reloadblocks")
	cmdlib.registerServerCommand("superdice_reloadconfig",ReloadConfig,"Reloads Super Dice's config. | superdice_reloadconfig")
	cmdlib.registerServerCommand("superdice_createhelp",CreateHelp,"Creates the help popup. | superdice_createhelp")
	cmdlib.registerServerCommand("superdice_playerdata",PlayerData,"Lets you set/get/check Super Dice's playerdata. | superdice_playerdata <set/get/check> <userid> <dataname> <setting/return var/return var>")
	es.loadevents("declare",events)
	es.loadevents(events)
	es.mexec(config)
	es.ServerVar("superdice_version").set("v0.1")
	es.ServerVar("superdice_version").makepublic()

def unload():
	for script in subscripts: es.unload("superdice/%s"%script)
	cmdlib.unregisterServerCommand("superdice_addblock")
	cmdlib.unregisterServerCommand("superdice_removeblock")
	cmdlib.unregisterServerCommand("superdice_clearblocks")
	cmdlib.unregisterServerCommand("superdice_reloadblocks")
	cmdlib.unregisterServerCommand("superdice_reloadconfig")
	cmdlib.unregisterServerCommand("superdice_createhelp")
	cmdlib.unregisterServerCommand("superdice_playerdata")

def es_map_start(ev):
	global roundend
	roundend = 0
	es.loadevents(events)
        players = {}

def popup_create():
        global superdice_help
        superdice_help = popuplib.easymenu("superdice_help",None,superdice_help)
        superdice_help.settitle("SuperDice Help Menu")
        for block in blocks: superdice_help.addoption(block,"%s - %s"%(blocks[block]["name"],blocks[block]["desc"]))

def check_player(userid):
        userid = str(userid)
        if userid not in players:
                players[userid] = {}
                players[userid]["roll"] = 0

def superdice_help(userid,choice,popupname):
        superdice_help.send(userid)

def AddBlock(args):
	if len(args) == 3:
		if args[0] not in blocks:
			blocks[args[0]] = {}
			blocks[args[0]]["name"] = args[1]
                        blocks[args[0]]["desc"] = args[2]
                        es.dbgmsg(0,"<addblock> Block was added. <%s - %s - %s>"%(args[0],args[1],args[2]))
		else: es.dbgmsg(0,"<addblock> You supplied a name thats already added. <%s>"%block)
	else: es.dbgmsg(0,"<addblock> You supplied more or less than three arguments.")

def RemoveBlock(args):
	if len(args) == 1:
		if args[0] in blocks:
			del blocks[args[0]]
			es.dbgmsg(0,"<removeblock> Block was removed. <%s>"%args[0])
		else: es.dbgmsg(0,"<removeblock> You supplied a name thats not added. <%s>"%block)
	else: es.dbgmsg(0,"<removeblock> You supplied more or less than one argument.")

def ClearBlocks(args):
	if len(blocks) > 0:
		blocks = {}
	else: es.dbgmsg(0,"<clearblocks> The blocks list is empty.")

def ReloadBlocks(args):
	es.reload("superdice/superdiceblocks")
	es.dbgmsg(0,"<reloadblocks> Blocks reloaded.")

def ReloadConfig(args):
        es.mexec(config)
	es.dbgmsg(0,"<reloadconfig> Config reloaded.")

def CreateHelp(args):
        popup_create()
        es.dbgmsg(0,"<createhelp> Help Menu created.")

def PlayerData(args):
        if len(args) == 4:
                if es.exists("userid",args[1]):
                        userid = str(args[1])
                        if userid in players:
                                if args[0] == "set":
                                        players[userid][args[2]] = args[3]
                                elif args[0] == "get":
                                        if args[2] in players[userid]: es.ServerVar(args[3]).set(players[userid][args[2]])
                                        else: es.dbgmsg(0,"<playerdata> Sorry, but it seems that the dataname you supplied does not exist, so can not get your requested data.")
                                elif args[0] == "check":
                                        if args[2] in players[userid]: es.ServerVar(args[3]).set(1)
                                        else: es.ServerVar(args[3]).set(0)
                                else: es.dbgmsg(0,"<playerdata> Argument one is not set,get, or check, please check your coding.")
                        else: es.dbgmsg(0,"<playerdata> The userid you supplied is not in the Super Dice player data.")
                else: es.dbgmsg(0,"<playerdata> The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"<playerdata> You supplied more or less than four arguments.")

def round_end(ev):
	global roundend
	roundend = 0

def round_start(ev):
	global roundend
	roundend = 1

def player_spawn(ev):
        check_player(ev["userid"])
        if int(players[ev["userid"]]["roll"]) == 1: players[ev["userid"]]["roll"] = 0

def player_say(ev):
	if ev["text"] == "!superdice" or ev["text"] == "superdice":
                check_player(ev["userid"])
		if es.getplayerprop(ev["userid"],"CCSPlayer.baseclass.pl.deadflag") == 0 and roundend == 1 and int(players[ev["userid"]]["roll"]) == 0:
                        rollchance = random.randint(1,100)
                        es.msg("%s - %s"%(rollchance,es.ServerVar("superdice_rollchance")))
                        if int(es.ServerVar("superdice_rollchance")) < rollchance:
                                roll = random.choice(blocks.keys())
                                if roll in blocks:
                                        rollname = blocks[roll]["name"]
                                        es.event("initialize","superdice_roll")
                                        es.event("setint","superdice_roll","userid",ev["userid"])
                                        es.event("setstring","superdice_roll","block",roll)
                                        es.event("setstring","superdice_roll","roll",rollname)
                                        es.event("fire","superdice_roll")
                                        es.doblock("superdice/superdiceblocks/%s"%roll)
                                        players[ev["userid"]]["roll"] = 1
                                        if int(es.ServerVar("superdice_shout")) == 1: es.msg("#multi","\x05%s rolled %s."%(es.getplayername(ev["userid"]),rollname))
                                        else: es.tell(ev["userid"],"#multi","\x05You rolled %s."%rollname)
                                else: es.tell(ev["userid"],"#multi","\x05Sorry, but theres been a error please roll again.")
                        else: es.tell(ev["userid"],"#multi","\x05Sorry, you failed to roll anything.")
		else: es.tell(ev["userid"],"#multi","\x05You cannot roll right now.")
        elif ev["text"] == "superdicehelp" or ev["text"] == "!superdicehelp":
                superdice_help.unsend(ev["userid"])
                gamethread.delayed(0.01,superdice_help.send,(ev["userid"]))
